![total.js logo](https://www.totaljs.com/img/logo-github.png)
---
[![NPM version][npm-version-image]][npm-url] [![NPM downloads][npm-downloads-image]][npm-url] [![MIT License][license-image]][license-url] [![Build Status][travis-image]][travis-url] [![Gitter chat](https://badges.gitter.im/totaljs/framework.png)](https://gitter.im/totaljs/framework)

---
Framework, for node.js
======================

__total.js__ is the web application framework for creating rich web sites and web services. The framework doesn't have any dependencies and it's written from the scratch. Please support the framework on social networks.

- [__NEW__: AppMonitor](https://github.com/totaljs/modules/tree/master/Miscellaneous/monitor) for tracking total.js applications
- [Total.js Simple Eshop + CMS](http://www.totaljs.com/eshop)
- [Total.js for enterprise](http://nodejsenterprise.com)


```
$ npm install total.js
```

- [Homepage](http://www.totaljs.com)
- [__Documentation__](http://docs.totaljs.com)
- [Gitter - Chat for GitHub](https://gitter.im/totaljs/framework)
- [Discussion forum](https://groups.google.com/forum/#!forum/totaljs)
- [Changelog](https://github.com/totaljs/framework/blob/master/changes.txt)
- [__Download__ empty-project with the framework](https://github.com/totaljs/framework/releases)
- [__Download__ Modules & Packages](https://github.com/totaljs/modules) (View Engines, Session, Auth, etc.)
- [__Download__ Examples](https://github.com/totaljs/examples)
- [__Make a donation__ via PayPal](http://www.totaljs.com/#make-a-donation)
- [Enterprise](http://www.nodejsenterprise.com)

## Social networks

Please support the framework on social networks.

- [Blogs](https://bufferwall.com/blogs/?tag=total.js)
- [Follow total.js on Gitter](https://gitter.im/totaljs/framework)
- [Follow total.js on GitHub](https://github.com/totaljs/framework)
- [Follow total.js on Twitter - __@totalframework__](https://twitter.com/totalframework)
- [Follow total.js on Facebook](https://www.facebook.com/totaljs.web.framework)
- [Follow total.js on Google Plus](https://plus.google.com/u/0/113175077493180148081/posts)
- [Follow total.js on LinkedIn](https://www.linkedin.com/groups/totaljs-8109884)

---

## Support for companies

We provide a support of the framework for companies. Our support services will keep your company worry free so you can focus on building products and growing your business.

- [Support form](http://www.totaljs.com/support/)
- Support e-mail: <support@totaljs.com>

## Features

[![Total.js trailer](https://www.totaljs.com/img/github-video.png)](https://vimeo.com/134131056)

| Name |
|------|
| [__Offline documentation__](http://docs.totaljs.com) |
| __Backward compatibility__ |
| HMVC architecture |
| Clean directory structure |
| Fully asynchronous |
| Full web server with serving of static files |
| Supports generators (node harmony) |
| Isomorphic code |
| Supports IP restrictions |
| Supports redirections |
| Supports just-in-time JS, CSS (variables and nesting) and HTML compressor |
| Supports just-in-time merging of static files (JavaScripts, CSS or HTML) |
| Supports just-in-time mapping of files |
| Supports media streaming (e.g. videos) |
| Supports modules and packages |
| Built-in image processing engine via ImageMagick or GraphicsMagick |
| Supports WebSockets (__RFC 6455__) and Server-Sent events |
| Supports RESTful routing |
| Supports middleware (like express.js) with custom options |
| Supports unit testing |
| Supports workers for heavy CPU operations |
| Supports 4x config files (common, debug, release and test) |
| Mailer with templating (Gmail, Outlook or classic SMTP servers with auth and TLS) |
| Built-in view engine (layouts, nested views, conditions, loops, inline helpers, etc.) |
| Localization with diff tool and CSV export |
| Supports cache mechanism |
| Supports schemas for creating business objects with validations, workflows, etc. |
| Supports injecting scripts, packages and views from URL |
| Supports String, Date, Number and Array prototypes |
| Supports additional utilities (e.g. create request, XML parsing, etc.) |
| Supports themes |
| Possibility to rewrite existing functionality |
| NoSQL embedded database |
| __You can use framework as single library__ `total.js (320 kB)` |

## Benevolent Dictator For Life (BDFL)

[Peter Širka](http://www.petersirka.eu), contact: <petersirka@gmail.com>

---

## Contributors

| Contributor | Type | E-mail |
|-------------|------|--------|
| [Jozef Gula](https://github.com/JozefGula) | contributor + support | <gula.jozef@gmail.com> |
| [Matus Szabo](https://github.com/matusszabo) | support + enterprise | <matus.szabo@gmail.com> |
| Tomas Holovsky | support + enterprise | <tomasholovsky@gmail.com> |
| [Andrea Sessa](https://github.com/asessa) | contributor | <andrea.sessa@gmail.com> |
| [Gera G. Güiles](https://github.com/Maxima-Solutions) | contributor | <gerardo.gonzalezg@gmail.com> |
| [Radek / rsmogura](https://github.com/rsmogura) | contributor | ... |
| [Liao San-Kai](https://github.com/liaosankai) | contributor | <liaosankai@gmail.com> |
| [Ivan Marchukov](https://github.com/deadman2000) | contributor | <marchukov.ivan@gmail.com> |
| [Dusan Dragula](https://github.com/DusanDragulaGR) | contributor | <dusan.dragula@goodrequest.com> |

## Other

#### Built with total.js

- [__NEW__: Eshop + CMS written in node.js / total.js](http://www.totaljs.com/eshop)
- [__NEW__: Todomator - www.todomator.com](https://www.todomator.com)
- [Componenator - Resources for web developers](http://www.componentator.com)
- [E-commerce, CMS and Docker manager](http://nowitssimple.com/)
- [Test your application](http://www.testerleader.com/)
- [MonitorGuru.com (Website monitoring)](https://www.monitorguru.com)
- [Bufferwall.com (Blog portal)](https://bufferwall.com)
- [Warstore.sk (E-commerce)](https://www.warstore.sk)
- [Privater (WebSocket) - www.privater.eu](https://www.privater.eu)
- [GPS Localization (WebSocket) - www.gpslocalization.com](http://www.gpslocalization.com)

#### Useful modules

- [SQL Agent: A missing ORM for node.js and total.js](https://github.com/petersirka/node-sqlagent)
- [MongoDB addons for better work with MongoDB and total.js](https://github.com/petersirka/mongodb-addons)
- [PayPal Express Checkout](https://github.com/petersirka/node-paypal-express-checkout)

[license-image]: https://img.shields.io/badge/license-MIT-blue.svg?style=flat
[license-url]: license.txt

[npm-url]: https://npmjs.org/package/total.js
[npm-version-image]: https://img.shields.io/npm/v/total.js.svg?style=flat
[npm-downloads-image]: https://img.shields.io/npm/dm/total.js.svg?style=flat

[travis-url]: https://travis-ci.org/totaljs/framework
[travis-image]: https://img.shields.io/travis/totaljs/framework.svg?style=flat
